OPENSSL-PKEY(1)

NAME
openssl-pkey - public or private key processing tool

SYNOPSIS
openssl pkey [-help] [-inform DER|PEM] [-outform DER|PEM] [-in filename] [-passin arg] [-out filename] [-passout arg] [-traditional] [-cipher] [-text] [-text_pub] [-noout] [-pubin] [-pubout] [-check] [-pubcheck] [-ec_conv_form arg] [-ec_param_enc arg] [-engine id]

DESCRIPTION
This command processes public or private keys. They can be converted between various forms and their components printed out.

OPTIONS

-help
    Print out a usage message.

-inform DER|PEM, -outform DER|PEM
    The input and formats; the default is PEM. See "Format Options" in openssl(1) for details.

-in filename
    This specifies the input filename to read a key from or standard input if this option is not specified. If the key is encrypted a pass phrase will be prompted for.

-passin arg, -passout arg
    The password source for the input and output file. For more information about the format of arg see "Pass Phrase Options" in openssl(1).

-out filename
    This specifies the output filename to write a key to or standard output if this option is not specified. If any encryption options are set then a pass phrase will be prompted for. The output filename should not be the same as the input filename.

-traditional
    Normally a private key is written using standard format: this is PKCS#8 form with the appropriate encryption algorithm (if any). If the -traditional option is specified then the older "traditional" format is used instead.

-cipher
    These options encrypt the private key with the supplied cipher. Any algorithm name accepted by EVP_get_cipherbyname() is acceptable such as des3.

-text
    Prints out the various public or private key components in plain text in addition to the encoded version.

-text_pub
    Print out only public key components even if a private key is being processed.

-noout
    Do not output the encoded version of the key.

-pubin
    By default a private key is read from the input file: with this option a public key is read instead.

-pubout
    By default a private key is output: with this option a public key will be output instead. This option is automatically set if the input is a public key.

-check
    This option checks the consistency of a key pair for both public and private components.

-pubcheck
    This option checks the correctness of either a public key or the public component of a key pair.

-ec_conv_form arg
    This option only applies to elliptic curve based public and private keys.

    This specifies how the points on the elliptic curve are converted into octet strings. Possible values are: compressed (the default value), uncompressed and hybrid. For more information regarding the point conversion forms please read the X9.62 standard. Note Due to patent issues the compressed option is disabled by default for binary curves and can be enabled by defining the preprocessor macro OPENSSL_EC_BIN_PT_COMP at compile time.

-ec_param_enc arg
    This option only applies to elliptic curve based public and private keys.

    This specifies how the elliptic curve parameters are encoded. Possible value are: named_curve, i.e. the ec parameters are specified by an OID, or explicit where the ec parameters are explicitly given (see RFC 3279 for the definition of the EC parameters structures). The default value is named_curve. Note the implicitlyCA alternative, as specified in RFC 3279, is currently not implemented in OpenSSL.

-engine id
    See "Engine Options" in openssl(1).

EXAMPLES
To remove the pass phrase on a private key:

 openssl pkey -in key.pem -out keyout.pem

To encrypt a private key using triple DES:

 openssl pkey -in key.pem -des3 -out keyout.pem

To convert a private key from PEM to DER format:

 openssl pkey -in key.pem -outform DER -out keyout.der

To print out the components of a private key to standard output:

 openssl pkey -in key.pem -text -noout

To print out the public components of a private key to standard output:

 openssl pkey -in key.pem -text_pub -noout

To just output the public part of a private key:

 openssl pkey -in key.pem -pubout -out pubkey.pem

To change the EC parameters encoding to explicit:

 openssl pkey -in key.pem -ec_param_enc explicit -out keyout.pem

To change the EC point conversion form to compressed:

 openssl pkey -in key.pem -ec_conv_form compressed -out keyout.pem

SEE ALSO
openssl(1), openssl-genpkey(1), openssl-rsa(1), openssl-pkcs8(1), openssl-dsa(1), openssl-genrsa(1), openssl-gendsa(1)

COPYRIGHT
Copyright 2006-2019 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at <https://www.openssl.org/source/license.html>.